<?php
/**
 * @version		$Id: variations.php,v 1.3 2010/05/10 10:32:20 juanca Exp $
 * @package		vpl. Variation definitions form
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../../../config.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once $CFG->libdir.'/formslib.php';
class mod_vpl_variation_option_form extends moodleform {
	function definition(){
		$mform    =& $this->_form;    
        $mform->addElement('header', 'variation_options', get_string('variation_options', VPL));
        $mform->addElement('hidden','id',required_param('id',PARAM_INT));
		$mform->addElement('selectyesno','usevariations',get_string('usevariations',VPL));
        $mform->addElement('text','variationtitle', get_string('variationtitle', VPL), array('size'=>80));
        $mform->setType('variationtitle', PARAM_TEXT);
		$buttongroup = array();
		$buttongroup[] = $mform->createElement('submit','save',get_string('save',VPL));
		$buttongroup[] = $mform->createElement('submit','cancel',get_string('cancel'));
		$mform->addGroup($buttongroup);
	}
};
class mod_vpl_variation_form extends moodleform {
	var $varid;
	var $number;
	public function __construct($page, $number, $varid=-1) { //-1 if new variation
		$this->number = $number;
		$this->varid = $varid;
		parent::__construct($page);
	}
	
	function definition(){
		$mform    =& $this->_form;
		if($this->number >=0){
			$title = get_string('variation', VPL,"{$this->number}");
		}else{
			$title = get_string('add');
		}
        $mform->addElement('header', 'variation'.($this->number+100), $title);
        $mform->addElement('hidden','id',required_param('id',PARAM_INT));
        $mform->addElement('hidden','varid',$this->varid);
        $mform->addElement('text', 'identification',get_string('varidentification', VPL),array('size'=>'20'));
		$mform->setDefault('identification','');
        $mform->setType('identification', PARAM_RAW);
        $mform->addElement('textarea', 'description', get_string('description', VPL), array('cols'=>60, 'rows'=>5));
        $mform->setType('description', PARAM_CLEANHTML);
		$mform->setDefault('description','');
		$buttongroup = array();
		$buttongroup[] = $mform->createElement('submit','save',get_string('save',VPL));
		$buttongroup[] = $mform->createElement('submit','cancel',get_string('cancel'));
		if($this->number >=0){
			$menssage = addslashes(get_string('delete'));
			$onclick ='onclick="return confirm(\''.$menssage.'\')"';
			$buttongroup[] = $mform->createElement('submit','delete',get_string('delete'),$onclick);
		}
		$mform->addGroup($buttongroup);
	}
};

$id = required_param('id',PARAM_INT);
$vpl = new mod_vpl($id);
$vplid= $vpl->get_instance()->id;
$vpl->require_capability(VPL_MANAGE_CAPABILITY);
//Display page
$vpl->print_header(get_string('variations',VPL));
$vpl->print_heading_with_help('variations');
$vpl->print_configure_tabs(basename(__FILE__));
$href= vpl_mod_href('forms/variations.php','id',$id);
$vpl->add_to_log('variations form', vpl_rel_url('forms/variations.php','id',$id));
//Generate default form and check for action
if(optional_param('varid',-13,PARAM_INT)==-13){ //No variation saved
	$oform = new mod_vpl_variation_option_form($href,$vpl);
	if ($oform->is_cancelled()){
		redirect($href); //Reload page
	}elseif ($fromform=$oform->get_data()){
		$fromform->id = $vplid;
		update_record(VPL,$fromform);
		redirect($href);
	}
	$vplinstmod = clone $vpl->get_instance();
	$vplinstmod->id = $id;
	$oform->set_data($vplinstmod);
	$oform->display();
}

$mform = new mod_vpl_variation_form($href,0);
if ($mform->is_cancelled()){
	redirect($href); //Reload page
} else if ($fromform=$mform->get_data()){
	if(isset($fromform->delete)){ //delete variation and its assignned variations to users
		if(delete_records(VPL_VARIATIONS,'id',$fromform->varid,'vpl',$vplid)){
			delete_records(VPL_ASSIGNED_VARIATIONS,'id',$fromform->varid); 
		}
	}else{
		if($fromform->varid == -1){ //New record
				$fromform->vpl = $vplid;
				unset($fromform->id);
				insert_record(VPL_VARIATIONS,$fromform);
		}else{ //update record
			if(get_record(VPL_VARIATIONS,'id',$fromform->varid,'vpl',$vplid)){//Check consistence
				$fromform->vpl = $vplid;
				$fromform->id = $fromform->varid;
				update_record(VPL_VARIATIONS,$fromform);
			}else{
				print_error(VPL_VARIATIONS.' record inconsistence',VPL,$href);
			}
		}
	}
	redirect($href);
}

//Get list of variations
$list = get_records('vpl_variations','vpl',$vplid,'id');

//Generate and show forms
$number=1;
if($list){
	foreach($list as $variation){
		$aform = new mod_vpl_variation_form($href,$number,$variation->id);
		$variation->varid = $variation->id;
		$variation->id = $id;
		$aform->set_data($variation);
		$aform->display();
		$number++;		
	}
}
$lastform = new mod_vpl_variation_form($href,-1);
$lastform->display();

$vpl->print_footer();
?>