<?php
/**
 * @version		$Id: sh_sql.class.php,v 1.6 2009/11/20 19:18:35 juanca Exp $
 * @package		vpl. vpl Syntaxhighlighter for SQL language
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/sh_base.class.php';

class vpl_sh_sql extends vpl_sh_base{
	protected function show_pending(&$rest){
		if(array_key_exists($rest  , $this->reserved)){
			$this->initTag(self::c_reserved);
			parent::show_pending($rest);
			echo self::endTag;
		}else{
			parent::show_pending($rest);
		}
	}
	protected function show_text($rest){
		parent::show_text($rest);
		if($rest == self::LF){
			$this->show_line_number();
		}
	}
	function __construct(){
		$this->reserved= array('CREATE' => 0, 'TABLE' => 0, 'DATABASE' => 0, 'DROP' => 0
		, 'ALTER' => 0, 'TRUNCATE' => 0,'INSERT' => 0, 'INTO' => 0
		, 'VALUES' => 0, 'SELECT' => 0, 'FROM' => 0, 'JOIN' => 0
		, 'WHERE' => 0, 'GROUP' => 0, 'BY' => 0
		, 'DISTINCT' => 0, 'HAVING' => 0, 'ORDER' => 0
		, 'INSERT' => 0, 'INTO' => 0, 'UPDATE' => 0
		, 'SET' => 0, 'DELETE' => 0, 'TO' => 0, 'INNER' => 0
		, 'OUTER' => 0, 'LEFT' => 0, 'GRANT' => 0);
		parent::__construct();
	}
	const normal=0;
	const in_string=1;
	const in_char=2;
	const in_comment=3;
	const in_line_comment=4;
	//TODO number detect
	const in_number=5;
	function print_file($filename, $filedata, $showln=true){
		$this->begin($filename,$showln);
		$state = self::normal;
		$pending='';
		$l = strlen($filedata);
		if($l){
			$this->show_line_number();
		}
		$current='';
		$previous='';
		for($i=0;$i<$l;$i++){
			//TODO call line_number
			$previous=$current;
			$current=$filedata[$i];
			if($i < ($l-1)) {
				$next = $filedata[$i+1];
			}else{
				$next ='';
			}
			if($current == self::CR){
				if($next == self::LF) {
					continue;
				}else{
					$current = self::LF;
				}
			}
			switch($state){
				case self::normal:{
					if($current >='A' && $current <='Z'){
						$pending .= $current;
					}else{
						if(strlen($pending)){
							$this->show_pending($pending);
						}
						if($current == '/' && $next == '*'){
							$state= self::in_comment;
							$this->initTag(self::c_comment);
						}
						if($current == '-' && $next == '-'){
							$state= self::in_line_comment;
							$this->initTag(self::c_comment);
						}
						if($current == '"')	{
							$state = self::in_string;
							$this->initTag(self::c_string);
						}
						if($current == "'")	{
							$state = self::in_char;
							$this->initTag(self::c_string);
						}
						$this->show_text($current);
					}
					break;
				}
				case self::in_line_comment: {
					$this->show_text($current);
					if($current==self::LF){
						$this->endTag();
						$state=self::normal;
					}
					break;
				}
				case self::in_comment: {
					$this->show_text($current);
					if($current== '*' && $next == '/'){
					    $this->show_text($next);
					    $i++;
						$this->endTag();
						$state=self::normal;
					}
					break;
				}
				case self::in_string: {
					$this->show_text($current);
					if($current=='"'){
						if($next=='"') {
							$this->show_text($current);
							$i++;
						}else{
							$this->endTag();
							$state=self::normal;
						}
					}
					break;
				}
				case self::in_char: {
					$this->show_text($current);
					if($current=="'"){
						$this->endTag();
						$state=self::normal;;
					}
					break;
				}
			}
		}
		$this->show_pending($pending);
		if($state != self::normal){
			$this->endTag();
		}
		$this->end();
	}
}

?>